#include <stdio.h>
#include <math.h>
#include <alloc.h>
#include <dos.h>
#include <stdlib.h>


void do_plasma (int x1,int y1,int x2,int y2,int rec_lev);
void putpixel(int x,int y,char col);
unsigned char getpixel(int x,int y);
unsigned char media(int x1,int y1,int x2,int y2,int rec_lev);


char *pal,*image,col;
union REGS r;
int i,x,y,a,b;
FILE *pf;
unsigned int ind;
unsigned int map[80][80];

main()
{
 r.x.ax=0X0013;
 int86(0X10,&r,&r);

 pal=malloc(768);
 pf=fopen("tubo.pal","rb");
 fread(pal,768,1,pf);
 fclose(pf);
 for(i=0;i<768;i+=3)
 {
  outportb(0X3C8,i/3);
  outportb(0X3C9,(*(pal+i))>>2);
  outportb(0X3C9,(*(pal+i+1))>>2);
  outportb(0X3C9,(*(pal+i+2))>>2);
 }
 free(pal);

 image=malloc(128*128);

 for(ind=0;ind<(128*128);ind++) *(image+ind)=0;

 randomize();
 putpixel(0,0,random(256));
 putpixel(0,127,random(256));
 putpixel(64,64,random(256));
 do_plasma(0,0,128,128,255);


 for(y=0;y<80;y++)
 {
  for(x=0;x<80;x++)
  {
   if(sqrt((float)x*x+(float)y*y)<5) map[x][y]=0;
   else
    if(x==0) map[x][y]=(int)(2500.0/sqrt((float)x*x+(float)y*y))%128*128 + 32;
    else
     map[x][y]=(int)(2500.0/sqrt((float)x*x+(float)y*y))%128*128 + 64.0/M_PI*atan((float)y/(float)x);
  }
 }

 while(!kbhit())
 {
  a++;
  while(!(inportb(0X03DA)&0X08));
  while(inportb(0X03DA)&0X08);
  for(y=0;y<100;y++)
  {
   for(x=0;x<160;x++)
   {
    if(x>=80 && y<50) ind=map[x-80][49-y];
    else
     if(x<80 && y<50) ind=map[49-y][79-x]+32;
      else
       if(x<80 && y>=50) ind=map[79-x][y-50]+64;
       else
	if(x>=80 && y>=50) ind=map[y-50][x-80]+96;
     col=*(image+((ind+(a<<8)+a)&0X3FFF));
     ind=(y<<9)+(y<<7)+(x<<1);
     asm {
      push  es
      mov   ax,0A000h
      mov   es,ax
      mov   di,ind
      mov   al,col
      mov   ah,al
      mov   es:[di],ax
      mov   es:[di+320],ax
      pop   es
     }
    }
   }
  }
 getch();
 free(image);
 r.x.ax=0X0003;
 int86(0X10,&r,&r);
 printf("Coded by Bellotti Stefano (Alias Signo).\n");
 return(0);
}



void do_plasma (int x1,int y1,int x2,int y2,int rec_lev)
{
 int x,y,col;

 x=(x2+x1)>>1;
 y=(y2+y1)>>1;
 if(x!=x1 || y!=y1)
 {
  if(getpixel(x,y1)==0) putpixel(x,y1,media(x1,y1,x2,y1,rec_lev));
  col=getpixel(x,y1);
  if(getpixel(x,y2)==0) putpixel(x,y2,media(x1,y2,x2,y2,rec_lev));
  col+=getpixel(x,y2);
  if(getpixel(x1,y)==0) putpixel(x1,y,media(x1,y1,x1,y2,rec_lev));
  col+=getpixel(x1,y);
  if(getpixel(x2,y)==0) putpixel(x2,y,media(x2,y1,x2,y2,rec_lev));
  col+=getpixel(x2,y);

  col=(col>>2)+random((int)rec_lev*2+2)-rec_lev;
  if(col<1) col=1;
  if(col>255) col=255;
  putpixel(x,y,col);

  do_plasma(x1,y1,x,y,rec_lev>>1);
  do_plasma(x,y1,x2,y,rec_lev>>1);
  do_plasma(x1,y,x,y2,rec_lev>>1);
  do_plasma(x,y,x2,y2,rec_lev>>1);
 }
}



void putpixel(int x,int y,char col)
{
 unsigned int ind;

 ind=(y%128)*128+x%128;
 *(image+ind)=col;
}




unsigned char getpixel(int x,int y)
{
 unsigned int ind;

 ind=(y%128)*128+x%128;
 return(*(image+ind));
}



unsigned char media(int x1,int y1,int x2,int y2,int rec_lev)
{
 int col;
 col=(((int)getpixel(x1,y1)+getpixel(x2,y2))>>1)+random((int)rec_lev*2+2)-rec_lev;
 if(col<1) col=1;
 if(col>255) col=255;
 return col;
}
